/* Developed for Lenovo Educational Board Pass 2
   © Lenovo Created by Joshua Grosser
   v. 1.0 */

#include "EEPROM.h"

// Create eeprom objects with name and size
EEPROMClass  NAMES("eeprom0");
EEPROMClass  HEIGHT("eeprom1");
EEPROMClass  AGE("eeprom2");

void setup() {
  // begin serial
  Serial.begin(115200);
  // wait 1 second for initialization
  delay(1000);
  // begin EEPROM classes with space in memory
  NAMES.begin(0x500)
  HEIGHT.begin(0x200)
  AGE.begin(0x100)

  // variables to be written to and read from EEPROM
  const char* name = "John Smith"; // change to your name
  char rname[32];
  double height = 5.8; // change to your height (feet.inch or meters)
  uint32_t age = 47; // change to your age

  // Write: Variables ---> EEPROM stores
  // use put method to store in EEPROM
  NAMES.writeString(0, name);
  HEIGHT.put(0, height);
  AGE.put(0, age);
  Serial.println("Writing to EEPROM:");
  Serial.print("name: ");   Serial.println(name);
  Serial.print("height: "); Serial.println(height);
  Serial.print("age: ");    Serial.println(age);
  Serial.println("------------------------------------\n");

  // Clear variables
  rname[0] = '\0';
  height = 0;
  age = 0;
  Serial.println("Clearing variables");
  Serial.print("name: ");   Serial.println(rname);
  Serial.print("height: "); Serial.println(height);
  Serial.print("age: ");    Serial.println(age);
  Serial.println("------------------------------------\n");

  // Read: Variables <--- EEPROM stores
  // use get method to read from EEPROM
  NAMES.get(0, rname);
  HEIGHT.get(0, height);
  AGE.get(0, age);
  Serial.println("Reading from EEPROM:");
  Serial.print("name: ");   Serial.println(rname);
  Serial.print("height: "); Serial.println(height);
  Serial.print("age: ");    Serial.println(age);
  
  Serial.println("Done!");
}

void loop() {
  delay(0xFFFFFFFF); // max delay value to prevent looping
}
